
cgilua.STATEDIR      = "c:/temp/"
cgilua.STATEMETHOD   = "url"
--cgilua.STATEMETHOD = "file"

function cgilua.tostring( value )
  local t = type( value )

  if t == "nil" then return "nil" 
  elseif t == "number" then return value
  elseif t == "string" then return format( "%q", value) 
  elseif t == "table"  then return cgilua.maketable( value )
  else return "nil"
  end
end

function cgilua.maketable( t )
  local f,v = next( t, nil )
  local s = "{" 

  while f do 
    s = s..format( "\n  [%s] = %s,", cgilua.tostring( f ), cgilua.tostring( v ) )
    f, v = next( t, f )
  end
  return s.."\n}"
end

function cgilua.persistvar( name )
  local luavar = getglobal( name )
  return format( "%s = %s\n", name, cgilua.tostring( luavar ) )
end

function cgilua.urlpersist( str )
  if not cgi.CGILUASTATE then
    cgi.CGILUASTATE = str
  else
    cgi.CGILUASTATE = cgi.CGILUASTATE .. ";" .. str
  end
end

function cgilua.statefile()
  local tmpdir, tmpname

  tmpdir, tmpname = cgilua.splitpath( tmpname() )
  if filetype( cgilua.STATEDIR ) == "directory" then
    tmpdir = cgilua.STATEDIR
  end

  return tmpdir .. tmpname
end

function cgilua.filepersist( str )
  if not cgi.CGILUASTATE then
    cgi.CGILUASTATE = cgilua.statefile()
  end

  local oldout = _OUTPUT
  if not writeto( cgi.CGILUASTATE ) then
    error( "Error opening file to save state information." )
  end
  write( str )
  write( "\n" )
  writeto( _OUTPUT )
end


function cgilua.savestate( ... )
  local i = 1
  local stateinfo = ""

  if arg.n == 0 then return nil end

  while i <= arg.n do
    stateinfo = stateinfo .. cgilua.persistvar( arg[i] ) .. '; '
    i = i + 1
  end

  if cgilua.STATEMETHOD == "url" then
    cgilua.urlpersist( stateinfo )
  elseif cgilua.STATEMETHOD == "file" then
    cgilua.filepersist( stateinfo )
  else
    error( "State saving method not specified." )
  end
end

function cgilua.restorestate()
  if cgi.CGILUASTATE then
    if cgilua.STATEMETHOD == "url" then
      if not dostring( cgi.CGILUASTATE ) then
	cgilua.error("Cannot restore state information.")
      end
    elseif cgilua.STATEMETHOD == "file" then
      if not dofile( cgi.CGILUASTATE ) then
	cgilua.error("Cannot execute state information file.")
      end
    else
      error( "State saving method not specified." )
    end
    cgi.CGILUASTATE = nil
  end
end
  
